diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/extended-capabilities.cc ns-3.43/src/wifi/model/extended-capabilities.cc
--- ns-3.42/src/wifi/model/extended-capabilities.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/extended-capabilities.cc	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2017
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -79,9 +68,7 @@
       m_protectedQloadReport(0),
       m_tdlsWiderBandwidth(0),
       m_operatingModeNotification(0),
-      m_maxNumberOfMsdusInAmsdu(0),
-      m_htSupported(0),
-      m_vhtSupported(0)
+      m_maxNumberOfMsdusInAmsdu(0)
 {
 }
 
@@ -97,27 +84,9 @@
     os << "Extended Capabilities=" << +GetExtendedCapabilitiesByte1();
 }
 
-void
-ExtendedCapabilities::SetHtSupported(uint8_t htSupported)
-{
-    m_htSupported = htSupported;
-}
-
-void
-ExtendedCapabilities::SetVhtSupported(uint8_t vhtSupported)
-{
-    m_vhtSupported = vhtSupported;
-}
-
 uint16_t
 ExtendedCapabilities::GetInformationFieldSize() const
 {
-    // we should not be here if it is not supported
-    NS_ASSERT(m_htSupported > 0 || m_vhtSupported > 0);
-    if (!m_vhtSupported)
-    {
-        return 1;
-    }
     return 8;
 }
 
@@ -334,23 +303,15 @@
 void
 ExtendedCapabilities::SerializeInformationField(Buffer::Iterator start) const
 {
-    if (m_htSupported > 0 && m_vhtSupported == 0)
-    {
-        // write the corresponding value for each bit
-        start.WriteU8(GetExtendedCapabilitiesByte1() & 0x7f);
-    }
-    else if (m_vhtSupported > 0)
-    {
-        // write the corresponding value for each bit
-        start.WriteU8(GetExtendedCapabilitiesByte1());
-        start.WriteU8(GetExtendedCapabilitiesByte2());
-        start.WriteU8(GetExtendedCapabilitiesByte3());
-        start.WriteU8(GetExtendedCapabilitiesByte4());
-        start.WriteU8(GetExtendedCapabilitiesByte5());
-        start.WriteU8(GetExtendedCapabilitiesByte6());
-        start.WriteU8(GetExtendedCapabilitiesByte7());
-        start.WriteU8(GetExtendedCapabilitiesByte8());
-    }
+    // write the corresponding value for each bit
+    start.WriteU8(GetExtendedCapabilitiesByte1());
+    start.WriteU8(GetExtendedCapabilitiesByte2());
+    start.WriteU8(GetExtendedCapabilitiesByte3());
+    start.WriteU8(GetExtendedCapabilitiesByte4());
+    start.WriteU8(GetExtendedCapabilitiesByte5());
+    start.WriteU8(GetExtendedCapabilitiesByte6());
+    start.WriteU8(GetExtendedCapabilitiesByte7());
+    start.WriteU8(GetExtendedCapabilitiesByte8());
 }
 
 uint16_t
@@ -358,24 +319,21 @@
 {
     Buffer::Iterator i = start;
     uint8_t byte1 = i.ReadU8();
+    uint8_t byte2 = i.ReadU8();
+    uint8_t byte3 = i.ReadU8();
+    uint8_t byte4 = i.ReadU8();
+    uint8_t byte5 = i.ReadU8();
+    uint8_t byte6 = i.ReadU8();
+    uint8_t byte7 = i.ReadU8();
+    uint8_t byte8 = i.ReadU8();
     SetExtendedCapabilitiesByte1(byte1);
-    if (m_vhtSupported > 0)
-    {
-        uint8_t byte2 = i.ReadU8();
-        uint8_t byte3 = i.ReadU8();
-        uint8_t byte4 = i.ReadU8();
-        uint8_t byte5 = i.ReadU8();
-        uint8_t byte6 = i.ReadU8();
-        uint8_t byte7 = i.ReadU8();
-        uint8_t byte8 = i.ReadU8();
-        SetExtendedCapabilitiesByte2(byte2);
-        SetExtendedCapabilitiesByte3(byte3);
-        SetExtendedCapabilitiesByte4(byte4);
-        SetExtendedCapabilitiesByte5(byte5);
-        SetExtendedCapabilitiesByte6(byte6);
-        SetExtendedCapabilitiesByte7(byte7);
-        SetExtendedCapabilitiesByte8(byte8);
-    }
+    SetExtendedCapabilitiesByte2(byte2);
+    SetExtendedCapabilitiesByte3(byte3);
+    SetExtendedCapabilitiesByte4(byte4);
+    SetExtendedCapabilitiesByte5(byte5);
+    SetExtendedCapabilitiesByte6(byte6);
+    SetExtendedCapabilitiesByte7(byte7);
+    SetExtendedCapabilitiesByte8(byte8);
     return length;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/extended-capabilities.h ns-3.43/src/wifi/model/extended-capabilities.h
--- ns-3.42/src/wifi/model/extended-capabilities.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/extended-capabilities.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2017
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -42,18 +31,6 @@
     void SerializeInformationField(Buffer::Iterator start) const override;
     uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) override;
     void Print(std::ostream& os) const override;
-    /**
-     * Set the HT Supported flag.
-     *
-     * \param htSupported flag whether HT is supported
-     */
-    void SetHtSupported(uint8_t htSupported);
-    /**
-     * Set the VHT Supported flag.
-     *
-     * \param vhtSupported flag whether VHT is supported
-     */
-    void SetVhtSupported(uint8_t vhtSupported);
 
     /**
      * Set the first byte in the Extended Capabilities information element.
@@ -160,7 +137,6 @@
     uint8_t m_psmpCapability;                        ///< PSMP Capability
     uint8_t m_spsmpSupport;                          ///< S-PSMP Support
 
-    // fields if VHT supported
     uint8_t m_event;                           ///< Event
     uint8_t m_diagnostics;                     ///< Diagnostics
     uint8_t m_multicastDiagnostics;            ///< Multicast Diagnostics
@@ -220,11 +196,6 @@
     uint8_t m_tdlsWiderBandwidth;         ///< TDLS Wider Bandwidth
     uint8_t m_operatingModeNotification;  ///< Operating Mode Notification
     uint8_t m_maxNumberOfMsdusInAmsdu;    ///< Max Number Of MSDUs In A-MSDU
-
-    uint8_t m_htSupported;  ///< Flag to indicate HT is supported in order to decide whether this
-                            ///< element should be added to the frame or not
-    uint8_t m_vhtSupported; ///< Flag to indicate VHT is supported in order to decide whether this
-                            ///< element should be added to the frame or not
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/fcfs-wifi-queue-scheduler.cc ns-3.43/src/wifi/model/fcfs-wifi-queue-scheduler.cc
--- ns-3.42/src/wifi/model/fcfs-wifi-queue-scheduler.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/fcfs-wifi-queue-scheduler.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2022 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/fcfs-wifi-queue-scheduler.h ns-3.43/src/wifi/model/fcfs-wifi-queue-scheduler.h
--- ns-3.42/src/wifi/model/fcfs-wifi-queue-scheduler.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/fcfs-wifi-queue-scheduler.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2022 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/frame-capture-model.cc ns-3.43/src/wifi/model/frame-capture-model.cc
--- ns-3.42/src/wifi/model/frame-capture-model.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/frame-capture-model.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2017
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/frame-capture-model.h ns-3.43/src/wifi/model/frame-capture-model.h
--- ns-3.42/src/wifi/model/frame-capture-model.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/frame-capture-model.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2017
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/frame-exchange-manager.cc ns-3.43/src/wifi/model/frame-exchange-manager.cc
--- ns-3.42/src/wifi/model/frame-exchange-manager.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/frame-exchange-manager.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -80,6 +69,8 @@
     m_navEnd = Simulator::Now();
     m_mpdu = nullptr;
     m_txParams.Clear();
+    m_ongoingRxInfo.macHdr.reset();
+    m_ongoingRxInfo.endOfPsduRx = Time{};
     m_dcf = nullptr;
 }
 
@@ -173,7 +164,10 @@
     m_phy = phy;
     m_phy->TraceConnectWithoutContext("PhyRxPayloadBegin",
                                       MakeCallback(&FrameExchangeManager::RxStartIndication, this));
+    m_phy->TraceConnectWithoutContext("PhyRxMacHeaderEnd",
+                                      MakeCallback(&FrameExchangeManager::ReceivedMacHdr, this));
     m_phy->SetReceiveOkCallback(MakeCallback(&FrameExchangeManager::Receive, this));
+    m_phy->SetReceiveErrorCallback(MakeCallback(&FrameExchangeManager::PsduRxError, this));
 }
 
 void
@@ -185,6 +179,9 @@
         m_phy->TraceDisconnectWithoutContext(
             "PhyRxPayloadBegin",
             MakeCallback(&FrameExchangeManager::RxStartIndication, this));
+        m_phy->TraceDisconnectWithoutContext(
+            "PhyRxMacHeaderEnd",
+            MakeCallback(&FrameExchangeManager::ReceivedMacHdr, this));
         if (m_phy->GetState())
         {
             m_phy->SetReceiveOkCallback(MakeNullCallback<void,
@@ -192,8 +189,11 @@
                                                          RxSignalInfo,
                                                          WifiTxVector,
                                                          std::vector<bool>>());
+            m_phy->SetReceiveErrorCallback(MakeNullCallback<void, Ptr<const WifiPsdu>>());
         }
         m_phy = nullptr;
+        m_ongoingRxInfo.macHdr.reset();
+        m_ongoingRxInfo.endOfPsduRx = Time{};
     }
 }
 
@@ -226,6 +226,12 @@
     return m_bssid;
 }
 
+MHz_u
+FrameExchangeManager::GetAllowedWidth() const
+{
+    return m_allowedWidth;
+}
+
 void
 FrameExchangeManager::SetDroppedMpduCallback(DroppedMpdu callback)
 {
@@ -261,10 +267,8 @@
 void
 FrameExchangeManager::NotifyPacketDiscarded(Ptr<const WifiMpdu> mpdu)
 {
-    if (!m_droppedMpduCallback.IsNull())
-    {
-        m_droppedMpduCallback(WIFI_MAC_DROP_REACHED_RETRY_LIMIT, mpdu);
-    }
+    NS_ASSERT(!m_droppedMpduCallback.IsNull());
+    m_droppedMpduCallback(WIFI_MAC_DROP_REACHED_RETRY_LIMIT, mpdu);
 }
 
 void
@@ -292,10 +296,41 @@
     {
         m_navResetEvent.Cancel();
     }
+
+    m_ongoingRxInfo = {std::nullopt, txVector, Simulator::Now() + psduDuration};
+}
+
+void
+FrameExchangeManager::ReceivedMacHdr(const WifiMacHeader& macHdr,
+                                     const WifiTxVector& txVector,
+                                     Time psduDuration)
+{
+    NS_LOG_FUNCTION(this << macHdr << txVector << psduDuration.As(Time::MS));
+    m_ongoingRxInfo = {macHdr, txVector, Simulator::Now() + psduDuration};
+}
+
+std::optional<std::reference_wrapper<const FrameExchangeManager::OngoingRxInfo>>
+FrameExchangeManager::GetOngoingRxInfo() const
+{
+    if (m_ongoingRxInfo.endOfPsduRx >= Simulator::Now())
+    {
+        return m_ongoingRxInfo;
+    }
+    return std::nullopt;
+}
+
+std::optional<std::reference_wrapper<const WifiMacHeader>>
+FrameExchangeManager::GetReceivedMacHdr() const
+{
+    if (auto info = GetOngoingRxInfo(); info.has_value() && info->get().macHdr.has_value())
+    {
+        return info->get().macHdr.value();
+    }
+    return std::nullopt;
 }
 
 bool
-FrameExchangeManager::StartTransmission(Ptr<Txop> dcf, uint16_t allowedWidth)
+FrameExchangeManager::StartTransmission(Ptr<Txop> dcf, MHz_u allowedWidth)
 {
     NS_LOG_FUNCTION(this << dcf << allowedWidth);
 
@@ -1107,6 +1142,12 @@
 }
 
 void
+FrameExchangeManager::PsduRxError(Ptr<const WifiPsdu> psdu)
+{
+    NS_LOG_FUNCTION(this << psdu);
+}
+
+void
 FrameExchangeManager::Receive(Ptr<const WifiPsdu> psdu,
                               RxSignalInfo rxSignalInfo,
                               WifiTxVector txVector,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/frame-exchange-manager.h ns-3.43/src/wifi/model/frame-exchange-manager.h
--- ns-3.42/src/wifi/model/frame-exchange-manager.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/frame-exchange-manager.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -37,6 +26,9 @@
 
 #include "ns3/object.h"
 
+#include <functional>
+#include <optional>
+
 #define WIFI_FEM_NS_LOG_APPEND_CONTEXT                                                             \
     std::clog << "[link=" << +m_linkId << "][mac=" << m_self << "] "
 
@@ -52,6 +44,14 @@
  *
  * FrameExchangeManager is a base class handling the basic frame exchange
  * sequences for non-QoS stations.
+ *
+ * The fragmentation policy implemented uses a simple fragmentation
+ * threshold: any packet bigger than this threshold is fragmented
+ * in fragments whose size is smaller than the threshold.
+ *
+ * The retransmission policy is also very simple: every packet is
+ * retransmitted until it is either successfully transmitted or
+ * it has been retransmitted up until the SSRC or SLRC thresholds.
  */
 class FrameExchangeManager : public Object
 {
@@ -78,10 +78,10 @@
      *
      * \param dcf the channel access function that gained channel access. It is
      *            the DCF on non-QoS stations and an EDCA on QoS stations.
-     * \param allowedWidth the allowed width in MHz for the frame exchange sequence
+     * \param allowedWidth the allowed width for the frame exchange sequence
      * \return true if a frame exchange sequence was started, false otherwise
      */
-    virtual bool StartTransmission(Ptr<Txop> dcf, uint16_t allowedWidth);
+    virtual bool StartTransmission(Ptr<Txop> dcf, MHz_u allowedWidth);
 
     /**
      * This method is intended to be called by the PHY layer every time an MPDU
@@ -100,6 +100,31 @@
                  std::vector<bool> perMpduStatus);
 
     /**
+     * Information about the MPDU being received. The TXVECTOR is populated upon
+     * PHY-RXSTART indication; the MAC header is populated when notified by the PHY.
+     */
+    struct OngoingRxInfo
+    {
+        std::optional<WifiMacHeader> macHdr; //!< MAC header of the MPDU being received
+        WifiTxVector txVector;               //!< TXVECTOR of the MPDU being received
+        Time endOfPsduRx;                    //!< time when reception of PSDU ends
+    };
+
+    /**
+     * \return the information about the MPDU being received by the PHY, if any. This information
+     *         is available from the time the PHY-RXSTART.indication is received until the end
+     *         of PSDU reception
+     */
+    std::optional<std::reference_wrapper<const OngoingRxInfo>> GetOngoingRxInfo() const;
+
+    /**
+     * \return the information about the MAC header of the MPDU being received by the PHY, if any.
+     *         The MAC header is available from the time its reception is completed until the end
+     *         of PSDU reception
+     */
+    std::optional<std::reference_wrapper<const WifiMacHeader>> GetReceivedMacHdr() const;
+
+    /**
      * Set the ID of the link this Frame Exchange Manager is associated with.
      *
      * \param linkId the ID of the link this Frame Exchange Manager is associated with
@@ -176,6 +201,10 @@
      */
     Mac48Address GetBssid() const;
     /**
+     * \return the width of the channel that the FEM is allowed to use for the current transmission
+     */
+    MHz_u GetAllowedWidth() const;
+    /**
      * Set the callback to invoke when an MPDU is dropped.
      *
      * \param callback the callback to invoke when an MPDU is dropped
@@ -333,6 +362,13 @@
     virtual void NavResetTimeout();
 
     /**
+     * This method is called when the reception of a PSDU fails.
+     *
+     * \param psdu the PSDU whose reception failed
+     */
+    virtual void PsduRxError(Ptr<const WifiPsdu> psdu);
+
+    /**
      * This method handles the reception of an MPDU (possibly included in an A-MPDU)
      *
      * \param mpdu the received MPDU
@@ -479,10 +515,10 @@
     std::set<Mac48Address> m_sentRtsTo; //!< the STA(s) which we sent an RTS to (waiting for CTS)
     std::set<Mac48Address> m_protectedStas; //!< STAs that have replied to an RTS in this TXOP
     uint8_t m_linkId;                       //!< the ID of the link this object is associated with
-    uint16_t m_allowedWidth;           //!< the allowed width in MHz for the current transmission
-    bool m_promisc;                    //!< Flag if the device is operating in promiscuous mode
-    DroppedMpdu m_droppedMpduCallback; //!< the dropped MPDU callback
-    AckedMpdu m_ackedMpduCallback;     //!< the acknowledged MPDU callback
+    MHz_u m_allowedWidth;                   //!< the allowed width for the current transmission
+    bool m_promisc;                         //!< Flag if the device is operating in promiscuous mode
+    DroppedMpdu m_droppedMpduCallback;      //!< the dropped MPDU callback
+    AckedMpdu m_ackedMpduCallback;          //!< the acknowledged MPDU callback
 
     /**
      * Finalize the MAC header of the MPDUs in the given PSDU before transmission. Tasks
@@ -650,6 +686,17 @@
      */
     virtual void RxStartIndication(WifiTxVector txVector, Time psduDuration);
 
+    /**
+     * Store information about the MAC header of the MPDU being received.
+     *
+     * \param macHdr the MAC header of the MPDU being received
+     * \param txVector the TXVECTOR used to transmit the PSDU
+     * \param psduDuration the remaining duration of the PSDU
+     */
+    virtual void ReceivedMacHdr(const WifiMacHeader& macHdr,
+                                const WifiTxVector& txVector,
+                                Time psduDuration);
+
   private:
     /**
      * Send the current MPDU, which can be acknowledged by a Normal Ack.
@@ -662,6 +709,9 @@
     bool m_moreFragments;           //!< true if a fragment has to be sent after a SIFS
     Ptr<WifiProtectionManager> m_protectionManager; //!< Protection manager
     Ptr<WifiAckManager> m_ackManager;               //!< Acknowledgment manager
+
+    OngoingRxInfo
+        m_ongoingRxInfo{}; //!< information about the MAC header of the MPDU being received
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/constant-obss-pd-algorithm.cc ns-3.43/src/wifi/model/he/constant-obss-pd-algorithm.cc
--- ns-3.42/src/wifi/model/he/constant-obss-pd-algorithm.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/constant-obss-pd-algorithm.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2018 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -72,7 +61,7 @@
 void
 ConstantObssPdAlgorithm::ReceiveHeSigA(HeSigAParameters params)
 {
-    NS_LOG_FUNCTION(this << +params.bssColor << WToDbm(params.rssiW));
+    NS_LOG_FUNCTION(this << +params.bssColor << params.rssi);
 
     Ptr<StaWifiMac> mac = m_device->GetMac()->GetObject<StaWifiMac>();
     if (mac && !mac->IsAssociated())
@@ -100,12 +89,12 @@
     bool isObss = (bssColor != params.bssColor);
     if (isObss)
     {
-        const double obssPdLevel = GetObssPdLevel();
-        if (WToDbm(params.rssiW) < obssPdLevel)
+        const auto obssPdLevel = GetObssPdLevel();
+        if (params.rssi < obssPdLevel)
         {
-            NS_LOG_DEBUG("Frame is OBSS and RSSI " << WToDbm(params.rssiW)
-                                                   << " is below OBSS-PD level of " << obssPdLevel
-                                                   << "; reset PHY to IDLE");
+            NS_LOG_DEBUG("Frame is OBSS and RSSI "
+                         << params.rssi << " dBm is below OBSS-PD level of " << obssPdLevel
+                         << " dBm; reset PHY to IDLE");
             ResetPhy(params);
         }
         else
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/constant-obss-pd-algorithm.h ns-3.43/src/wifi/model/he/constant-obss-pd-algorithm.h
--- ns-3.42/src/wifi/model/he/constant-obss-pd-algorithm.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/constant-obss-pd-algorithm.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2018 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/he-6ghz-band-capabilities.cc ns-3.43/src/wifi/model/he/he-6ghz-band-capabilities.cc
--- ns-3.42/src/wifi/model/he/he-6ghz-band-capabilities.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/he-6ghz-band-capabilities.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2024
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Rami Abdallah <abdallah.rami@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/he-6ghz-band-capabilities.h ns-3.43/src/wifi/model/he/he-6ghz-band-capabilities.h
--- ns-3.42/src/wifi/model/he/he-6ghz-band-capabilities.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/he-6ghz-band-capabilities.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2024
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Rami Abdallah <abdallah.rami@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/he-capabilities.cc ns-3.43/src/wifi/model/he/he-capabilities.cc
--- ns-3.42/src/wifi/model/he/he-capabilities.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/he-capabilities.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2016
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
